require 'rails'
require 'disco_client'
require 'pp'

class DiscoClientRails < ::Rails::Railtie
	class << self
		attr_accessor :service
	end

	config.before_configuration do |app|
		initializer = ::Rails.root.join('config', 'initializers', 'disco.rb')
		require initializer if File.exist?(initializer)

		raise 'set DiscoClientRails.service in config/initializers/disco.rb' unless self.service

		dc = DiscoClient.new
		dc.register(self.service)
		config = dc.get_configuration

		pp config

		services = {}
		config[:services].each do |svc|
			services[svc[:id].to_sym] = svc
		end

		config[:services] = services

		pp config

		app.config.x.disco = config
	end
end
